unit ID3d ;

interface

uses Windows, ID3dtypes, ID3dcaps, IDDraw ;

(*==========================================================================;
 *
 *  Copyright (C) 1995,1996 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       d3d.h
 *  Content:    Direct3D include file
 *
 *  DirectX 3 Delphi adaptation by Blake Stone
 *
 *    EMail:     bstone@dkw.com
 *    Home Page: http://www.dkw.com/bstone
 *
 *  DirectX 3 Delphi 3 adaptation by Paolo Rainone
 *
 *    EMail:     rainone@programmers.net
 ***************************************************************************)

{$Z4}
{$A+}

(*
 * Interface IID's
 *)

const
  IID_IDirect3D             : TGUID = '{3BBA0080-2421-11CF-A31A-00AA00B93356}';
  IID_IDirect3DTexture      : TGUID = '{2CDCD9E0-25A0-11CF-A31A-00AA00B93356}';
  IID_IDirect3DLight        : TGUID = '{4417C142-33AD-11CF-816F-0000C020156E}';
  IID_IDirect3DMaterial     : TGUID = '{4417C144-33AD-11CF-816F-0000C020156E}';
  IID_IDirect3DExecuteBuffer: TGUID = '{4417C145-33AD-11CF-816F-0000C020156E}';
  IID_IDirect3DViewport     : TGUID = '{4417C146-33AD-11CF-816F-0000C020156E}';

(*
 * Flags for execute buffer calls
 *)

  D3DNEXT_NEXT    = $00000001 ;
  D3DNEXT_HEAD    = $00000002 ;
  D3DNEXT_TAIL    = $00000004 ;

(*
 * Data structures
 *)

type
  IDirect3D = interface ;
  IDirect3DDevice = interface ;
  IDirect3DExecuteBuffer = interface ;
  IDirect3DLight = interface ;
  IDirect3DMaterial = interface ;
  IDirect3DTexture = interface ;
  IDirect3DViewport = interface ;

(*
 * IDirect3D
 *)

  IDirect3D = interface ( IUnknown )
    ['{3BBA0080-2421-11CF-A31A-00AA00B93356}']
    (*** IDirect3D methods ***)
    function Initialize ( lpREFIID: {REFIID} PGUID ): HRESULT ; stdcall;
    function EnumDevices ( lpEnumDevicesCallback: LPD3DENUMDEVICESCALLBACK ;
        lpUserArg : pointer): HRESULT ; stdcall;
    function CreateLight ( var lplpDirect3Dlight: IDirect3DLight ;
        pUnkOuter: IUnknown ): HRESULT ; stdcall;
    function CreateMaterial ( var lplpDirect3DMaterial: IDirect3DMaterial ;
        pUnkOuter: IUnknown ): HRESULT ; stdcall;
    function CreateViewport ( var lplpD3DViewport: IDirect3DViewport ;
        pUnkOuter: IUnknown ): HRESULT ; stdcall;
    function FindDevice ( const lpD3DFDS: TD3DFINDDEVICESEARCH ;
        var lpD3DFDR: TD3DFINDDEVICERESULT ): HRESULT ; stdcall;
  end ;

(*
 * IDirect3DDevice
 *)

  IDirect3DDevice = interface ( IUnknown )
    (*** IDirect3DDevice methods ***)
    function Initialize ( lpd3d: IDirect3D ; lpGUID: PGUID ;
                          const lpd3ddvdesc: TD3DDEVICEDESC ): HRESULT ; stdcall;
    function GetCaps ( var lpD3DHWDevDesc: TD3DDEVICEDESC ;
                       var lpD3DHELDevDesc: TD3DDEVICEDESC ): HRESULT ; stdcall;
    function SwapTextureHandles ( lpD3DTex1: IDirect3DTexture ;
                                  lpD3DTex2: IDirect3DTexture ): HRESULT ; stdcall;
    function CreateExecuteBuffer ( const lpDesc: TD3DEXECUTEBUFFERDESC  ;
        var lplpDirect3DExecuteBuffer: IDirect3DExecuteBuffer ;
        out pUnkOuter: IUnknown ): HRESULT ; stdcall;
    function GetStats ( var lpD3DStats: TD3DSTATS ): HRESULT ; stdcall;
    function Execute ( lpDirect3DExecuteBuffer: IDirect3DExecuteBuffer ;
                       lpDirect3DViewport: IDirect3DViewport ;
                       dwFlags: DWORD ): HRESULT ; stdcall;
    function AddViewport( lpDirect3DViewport: IDirect3DViewport ): HRESULT ; stdcall;
    function DeleteViewport( lpDirect3DViewport: IDirect3DViewport ): HRESULT ; stdcall;
    function NextViewport ( lpDirect3DViewport: IDirect3DViewport ;
                            var lplpDirect3DViewport: IDirect3DViewport ;
                            dwFlags: DWORD ): HRESULT ; stdcall;
    function Pick ( lpDirect3DExecuteBuffer: IDirect3DExecuteBuffer ;
                    lpDirect3DViewport: IDirect3DViewport ; dwFlags: DWORD ;
                    const lpRect: TD3DRECT ): HRESULT ; stdcall;
    function GetPickRecords ( var lpCount: DWORD ;
                              var lpD3DPickRec: TD3DPICKRECORD ): HRESULT ; stdcall;
    function EnumTextureFormats (
        lpd3dEnumTextureProc: LPD3DENUMTEXTUREFORMATSCALLBACK ;
        lpArg: Pointer): HRESULT ; stdcall;
    function CreateMatrix ( var lpD3DMatHandle: TD3DMATRIXHANDLE ): HRESULT ; stdcall;
    function SetMatrix ( d3dMatHandle: TD3DMATRIXHANDLE ;
                         const lpD3DMatrix: TD3DMATRIX ): HRESULT ; stdcall;
    function GetMatrix ( const lpD3DMatHandle: TD3DMATRIXHANDLE ;
                         var lpD3DMatrix: TD3DMATRIX ): HRESULT ; stdcall;
    function DeleteMatrix ( d3dMatHandle: TD3DMATRIXHANDLE ): HRESULT ; stdcall;
    function BeginScene: HRESULT ; stdcall;
    function EndScene: HRESULT ; stdcall;
    function GetDirect3D( var lpD3D: IDirect3D ): HRESULT ; stdcall;
  end ;

(*
 * IDirect3DExecuteBuffer
 *)

  IDirect3DExecuteBuffer = interface ( IUnknown )
    ['{4417C145-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DExecuteBuffer methods ***)
    function Initialize ( lpDirect3DDevice: IDirect3DDevice ;
        const lpDesc: TD3DEXECUTEBUFFERDESC ): HRESULT ; stdcall;
    function Lock ( const lpDesc: TD3DEXECUTEBUFFERDESC ): HRESULT ; stdcall;
    function Unlock: HRESULT ; stdcall;
    function SetExecuteData ( const lpData: TD3DEXECUTEDATA ): HRESULT ; stdcall;
    function GetExecuteData ( var lpData: TD3DEXECUTEDATA ): HRESULT ; stdcall;
    function Validate ( var lpdwOffset: DWORD ; lpFunc: LPD3DVALIDATECALLBACK ;
        lpUserArg: Pointer ; dwReserved: DWORD ): HRESULT ; stdcall;
    (*** Warning!  Optimize is defined differently in the header files
         and the online documentation ***)
    function Optimize ( dwFlags: DWORD ): HRESULT ; stdcall;
  end ;

(*
 * IDirect3DLight
 *)

  IDirect3DLight = interface ( IUnknown )
    ['{4417C142-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DLight methods ***)
    function Initialize ( lpDirect3D: IDirect3D ): HRESULT ; stdcall;
    function SetLight ( const lpLight: TD3DLIGHT ): HRESULT ; stdcall;
    function GetLight ( var lpLight: TD3DLIGHT ): HRESULT ; stdcall;
  end ;

(*
 * IDirect3DMaterial
 *)

  IDirect3DMaterial = interface ( IUnknown )
    ['{4417C144-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DMaterial methods ***)
    function Initialize ( lpDirect3D: IDirect3D): HRESULT ; stdcall;
    function SetMaterial ( const lpMat: TD3DMATERIAL ): HRESULT ; stdcall;
    function GetMaterial ( var lpMat: TD3DMATERIAL ): HRESULT ; stdcall;
    function GetHandle ( lpDirect3DDevice: IDirect3DDevice ;
                         var lpHandle: TD3DMATERIALHANDLE ): HRESULT ; stdcall;
    function Reserve: HRESULT ; stdcall;
    function Unreserve: HRESULT ; stdcall;
  end ;

(*
 * IDirect3DTexture
 *)

  IDirect3DTexture = interface ( IUnknown )
    ['{2CDCD9E0-25A0-11CF-A31A-00AA00B93356}']
    (*** IDirect3DTexture methods ***)
    function Initialize ( lpD3DDevice: IDirect3DDevice ;
                          lpDDSurface: IDirectDrawSurface ): HRESULT ; stdcall;
    function GetHandle ( lpDirect3DDevice: IDirect3DDevice ;
                         var lpHandle: TD3DTEXTUREHANDLE ): HRESULT ; stdcall;
    function PaletteChanged ( dwStart: DWORD ; dwCount: DWORD ): HRESULT ; stdcall;
    function Load ( lpD3DTexture: IDirect3DTexture ): HRESULT ; stdcall;
    function Unload: HRESULT ; stdcall;
  end ;

(*
 * IDirect3DViewport
 *)

  IDirect3DViewport = interface ( IUnknown )
    ['{4417C146-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DViewport methods ***)
    function Initialize ( lpDirect3D: IDirect3D ): HRESULT ; stdcall;
    function GetViewport ( var lpData: TD3DVIEWPORT ): HRESULT ; stdcall;
    function SetViewport ( const lpData: TD3DVIEWPORT ): HRESULT ; stdcall;
    function TransformVertices ( dwVertexCount: DWORD ;
        var lpData: TD3DTRANSFORMDATA ; dwFlags: DWORD ;
        var lpOffscreen: DWORD ): HRESULT ; stdcall;
    function LightElements ( dwElementCount: DWORD ;
        var lpData: TD3DLIGHTDATA ): HRESULT ; stdcall;
    function SetBackground ( hMat: TD3DMATERIALHANDLE ): HRESULT ; stdcall;
    function GetBackground ( hMat: TD3DMATERIALHANDLE ): HRESULT ; stdcall;
    function SetBackgroundDepth ( lpDDSurface: IDirectDrawSurface ): HRESULT ; stdcall;
    function GetBackgroundDepth ( var lplpDDSurface: IDirectDrawSurface ;
        var lpValid: BOOL ): HRESULT ; stdcall;
    function Clear ( dwCount: DWORD ; const lpRects: TD3DRECT ; dwFlags: DWORD ): HRESULT ; stdcall;
    function AddLight ( lpDirect3DLight: IDirect3DLight ): HRESULT ; stdcall;
    function DeleteLight ( lpDirect3DLight: IDirect3DLight ): HRESULT ; stdcall;
    function NextLight ( lpDirect3DLight: IDirect3DLight ;
                         var lplpDirect3DLight: IDirect3DLight ;
                         dwFlags: DWORD ): HRESULT ; stdcall;
  end ;

(*
 * Direct3D Errors
 * DirectDraw error codes are used when errors not specified here.
 *)

const
  D3D_OK                          = DD_OK ;
  D3DERR_BADMAJORVERSION          = $88760000 + 700 ;
  D3DERR_BADMINORVERSION          = $88760000 + 701 ;

  D3DERR_EXECUTE_CREATE_FAILED    = $88760000 + 710 ;
  D3DERR_EXECUTE_DESTROY_FAILED   = $88760000 + 711 ;
  D3DERR_EXECUTE_LOCK_FAILED      = $88760000 + 712 ;
  D3DERR_EXECUTE_UNLOCK_FAILED    = $88760000 + 713 ;
  D3DERR_EXECUTE_LOCKED           = $88760000 + 714 ;
  D3DERR_EXECUTE_NOT_LOCKED       = $88760000 + 715 ;

  D3DERR_EXECUTE_FAILED           = $88760000 + 716 ;
  D3DERR_EXECUTE_CLIPPED_FAILED   = $88760000 + 717 ;

  D3DERR_TEXTURE_NO_SUPPORT       = $88760000 + 720 ;
  D3DERR_TEXTURE_CREATE_FAILED    = $88760000 + 721 ;
  D3DERR_TEXTURE_DESTROY_FAILED   = $88760000 + 722 ;
  D3DERR_TEXTURE_LOCK_FAILED      = $88760000 + 723 ;
  D3DERR_TEXTURE_UNLOCK_FAILED    = $88760000 + 724 ;
  D3DERR_TEXTURE_LOAD_FAILED      = $88760000 + 725 ;
  D3DERR_TEXTURE_SWAP_FAILED      = $88760000 + 726 ;
  D3DERR_TEXTURE_LOCKED           = $88760000 + 727 ;
  D3DERR_TEXTURE_NOT_LOCKED       = $88760000 + 728 ;
  D3DERR_TEXTURE_GETSURF_FAILED   = $88760000 + 729 ;

  D3DERR_MATRIX_CREATE_FAILED     = $88760000 + 730 ;
  D3DERR_MATRIX_DESTROY_FAILED    = $88760000 + 731 ;
  D3DERR_MATRIX_SETDATA_FAILED    = $88760000 + 732 ;
  D3DERR_MATRIX_GETDATA_FAILED    = $88760000 + 733 ;
  D3DERR_SETVIEWPORTDATA_FAILED   = $88760000 + 734 ;

  D3DERR_MATERIAL_CREATE_FAILED   = $88760000 + 740 ;
  D3DERR_MATERIAL_DESTROY_FAILED  = $88760000 + 741 ;
  D3DERR_MATERIAL_SETDATA_FAILED  = $88760000 + 742 ;
  D3DERR_MATERIAL_GETDATA_FAILED  = $88760000 + 743 ;

  D3DERR_LIGHT_SET_FAILED         = $88760000 + 750 ;

  D3DERR_SCENE_IN_SCENE           = $88760000 + 760 ;
  D3DERR_SCENE_NOT_IN_SCENE       = $88760000 + 761 ;
  D3DERR_SCENE_BEGIN_FAILED       = $88760000 + 762 ;
  D3DERR_SCENE_END_FAILED         = $88760000 + 763 ;

procedure DisableFPUExceptions ;
procedure EnableFPUExceptions ;

implementation

procedure DisableFPUExceptions ;
var
  FPUControlWord: WORD ;
asm
  FSTCW   FPUControlWord ;
  OR      FPUControlWord, $4 + $1 ; { Divide by zero + invalid operation }
  FLDCW   FPUControlWord ;
end ;

procedure EnableFPUExceptions ;
var
  FPUControlWord: WORD ;
asm
  FSTCW   FPUControlWord ;
  AND     FPUControlWord, $FFFF - $4 - $1 ; { Divide by zero + invalid operation }
  FLDCW   FPUControlWord ;
end ;

initialization
  DisableFPUExceptions ;
end.
