unit ID3drm ;

interface

uses Windows, ID3DRMObj, ID3DTypes, ID3DRMDef, IDDraw, ID3D ;

(*==========================================================================;
 *
 *  Copyright (C) 1995-1996 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       d3drm.h
 *  Content:    Direct3DRM include file
 *
 *  DirectX 3 Delphi adaptation by Blake Stone
 *
 *    EMail:     bstone@dkw.com
 *    Home Page: http://www.dkw.com/bstone
 *
 *  DirectX 3 Delphi 3 adaptation by Paolo Rainone
 *
 *    EMail:     rainone@programmers.net
 ***************************************************************************)

{$Z4}
{$A+}

type
  //Corrected
  TD3DRMDEVICEPALETTECALLBACK = procedure ( lpDirect3DRMDev: IDirect3DRMDevice ;
      lpArg: Pointer ; dwIndex: DWORD ; red, green, blue: LongInt ) ; CDECL ;

const
  IID_IDirect3DRM: TGUID = '{2bc49361-8327-11cf-ac4a-0000c03825a1}';


type
  IDirect3DRM = interface ( IUnknown )
   ['{2bc49361-8327-11cf-ac4a-0000c03825a1}']
   
    function CreateObject ( rclsid: TGUID ; pUnkOuter: IUnknown ;
        riid: TGUID ; var ppv: Pointer ): HRESULT ; stdcall ;
    function CreateFrame ( lpD3DRMFrame: IDirect3DRMFrame ;
        var lplpD3DRMFrame: IDirect3DRMFrame ): HRESULT ; stdcall ;
    function CreateMesh ( var lplpD3DRMMesh: IDirect3DRMMesh ): HRESULT ;stdcall ;
    function CreateMeshBuilder ( var lplpD3DRMMeshBuilder:
        IDirect3DRMMeshBuilder ): HRESULT ; stdcall ;
    function CreateFace ( var lplpd3drmFace: IDirect3DRMFace ): HRESULT ; stdcall ;
    function CreateAnimation ( var lplpD3DRMAnimation: IDirect3DRMAnimation ):
        HRESULT ; stdcall ;
    function CreateAnimationSet ( var lplpD3DRMAnimationSet:
        IDirect3DRMAnimationSet ): HRESULT ; stdcall ;
    function CreateTexture ( const lpImage: TD3DRMIMAGE ;
        var lplpD3DRMTexture: IDirect3DRMTexture ): HRESULT ; stdcall ;
    function CreateLight ( d3drmltLightType: TD3DRMLIGHTTYPE ;
        cColor: TD3DCOLOR ; var lplpD3DRMLight: IDirect3DRMLight ): HRESULT ;
        stdcall;
    function CreateLightRGB ( ltLightType: TD3DRMLIGHTTYPE ; vRed,
        vGreen, vBlue: TD3DVALUE ; var lplpD3DRMLight: IDirect3DRMLight ):
        HRESULT ; stdcall;
    function CreateMaterial ( vPower: TD3DVALUE ; var lplpD3DRMMaterial:
        IDirect3DRMMaterial ): HRESULT ; stdcall;
    function CreateDevice ( dwWidth, dwHeight: DWORD ; var lplpD3DRMDevice:
        IDirect3DRMDevice ): HRESULT ; stdcall;

    (* Create a Windows Device using DirectDraw surfaces *)
    function CreateDeviceFromSurface ( lpGUID: PGUID ; lpDD: IDirectDraw ;
        lpDDSBack: IDirectDrawSurface ; var lplpD3DRMDevice: IDirect3DRMDevice ):
        HRESULT ; stdcall;

      (* Create a Windows Device using D3D objects *)
    function CreateDeviceFromD3D ( lpD3D: IDirect3D ; lpD3DDev: IDirect3DDevice ;
        var lplpD3DRMDevice: IDirect3DRMDevice ): HRESULT ; stdcall;

    function CreateDeviceFromClipper ( lpDDClipper: IDirectDrawClipper ;
        lpGUID: PGUID ; width, height: Integer ; var lplpD3DRMDevice:
        IDirect3DRMDevice ): HRESULT ; stdcall;

    //Corrected
    function CreateTextureFromSurface (  lpDDS: IDirectDrawSurface ;
        var lplpD3DRMTexture: IDirect3DRMTexture ): HRESULT ; stdcall;

    function CreateShadow ( lpVisual: IDirect3DRMVisual ;
        lpLight: IDirect3DRMLight ; px, py, pz, nx, ny, nz: TD3DVALUE ;
        var lplpShadow: IDirect3DRMVisual ): HRESULT ; stdcall;
    function CreateViewport ( lpDev: IDirect3DRMDevice ;
        lpCamera: IDirect3DRMFrame ; dwXPos, dwYPos, dwWidth, dwHeight: DWORD ;
        var lplpD3DRMViewport: IDirect3DRMViewport ): HRESULT ; stdcall;
    function CreateWrap ( wraptype: TD3DRMWRAPTYPE ; lpRef: IDirect3DRMFrame ;
        ox, oy, oz, dx, dy, dz, ux, uy, uz, ou, ov, su, sv: TD3DVALUE ;
        var lplpD3DRMWrap: IDirect3DRMWrap ): HRESULT ; stdcall;
    function CreateUserVisual ( fn: TD3DRMUSERVISUALCALLBACK ; lpArg: Pointer ;
        var lplpD3DRMUV: IDirect3DRMUserVisual ): HRESULT ; stdcall;
    function LoadTexture ( lpFileName: LPSTR ; var lplpD3DRMTexture:
        IDirect3DRMTexture ): HRESULT ; stdcall;
    function LoadTextureFromResource ( rs: HRSRC ; var lplpD3DRMTexture:
        IDirect3DRMTexture ): HRESULT ; stdcall;

    function SetSearchPath ( lpPath: LPSTR ): HRESULT ; stdcall;
    function AddSearchPath ( lpPath: LPSTR ): HRESULT ; stdcall;
    function GetSearchPath ( var lpdwSize: DWORD ; lpszPath: LPSTR ): HRESULT ;
        stdcall;
    function SetDefaultTextureColors ( dwColors: DWORD ): HRESULT ; stdcall;
    function SetDefaultTextureShades ( dwShades: DWORD ): HRESULT ; stdcall;

    function GetDevices ( var lplpDevArray: IDirect3DRMDeviceArray ): HRESULT ;
        stdcall;
    function GetNamedObject ( lpName: LPSTR ; var lplpD3DRMObject:
        IDirect3DRMObject ): HRESULT ; stdcall;

    function EnumerateObjects ( func: TD3DRMOBJECTCALLBACK ; lpArg: Pointer ):
        HRESULT ; stdcall;

    function Load ( lpvObjSource, lpvObjID: Pointer ;
                    var lplpGUIDs: PGUID ;
                    dwcGUIDs: DWORD ;
                    d3drmLOFlags: TD3DRMLOADOPTIONS ;
                    d3drmLoadProc: TD3DRMLOADCALLBACK ;
                    lpArgLP: Pointer ;
                    d3drmLoadTextureProc: TD3DRMLOADTEXTURECALLBACK ;
                    lpArgLTP: Pointer ;
                    lpParentFrame: IDirect3DRMFrame ): HRESULT ; stdcall;
                    
    function Tick ( d3dvalTick: TD3DVALUE ): HRESULT ; stdcall;

  end ;

const
  D3DRM_OK                        = DD_OK ;
  D3DRMERR_BADOBJECT              = $88760000 + 781 ;
  D3DRMERR_BADTYPE                = $88760000 + 782 ;
  D3DRMERR_BADALLOC               = $88760000 + 783 ;
  D3DRMERR_FACEUSED               = $88760000 + 784 ;
  D3DRMERR_NOTFOUND               = $88760000 + 785 ;
  D3DRMERR_NOTDONEYET             = $88760000 + 786 ;
  D3DRMERR_FILENOTFOUND           = $88760000 + 787 ;
  D3DRMERR_BADFILE                = $88760000 + 788 ;
  D3DRMERR_BADDEVICE              = $88760000 + 789 ;
  D3DRMERR_BADVALUE               = $88760000 + 790 ;
  D3DRMERR_BADMAJORVERSION        = $88760000 + 791 ;
  D3DRMERR_BADMINORVERSION        = $88760000 + 792 ;
  D3DRMERR_UNABLETOEXECUTE        = $88760000 + 793 ;

(* Create a Direct3DRM API *)
function Direct3DRMCreate ( var lplpDirect3DRM: IDirect3DRM ): HRESULT ; stdcall ;

implementation

function Direct3DRMCreate ; external 'D3DRM.DLL' ;

end.

