unit ID3drmobj ;

interface

uses Windows, ID3DRmDef, ID3D, ID3DTypes, IDDraw ;

(*==========================================================================;
 *
 *  Copyright (C) 1995-1996 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       d3drm.h
 *  Content:    Direct3DRM include file
 *
 *  DirectX 3 Delphi adaptation by Blake Stone
 *
 *    EMail:     bstone@dkw.com
 *    Home Page: http://www.dkw.com/bstone
 *
 *  DirectX 3 Delphi 3 adaptation by Paolo Rainone
 *
 *    EMail:     rainone@programmers.net
 ***************************************************************************)

{$Z4}
{$A+}

(*
 * Direct3DRM Object classes
 *)

const
  CLSID_CDirect3DRMDevice  : TGUID = '{4fa3568e-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMViewport: TGUID = '{4fa3568f-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMFrame   : TGUID = '{4fa35690-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMMesh    : TGUID = '{4fa35691-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMMeshBuilder:
                             TGUID = '{4fa35692-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMFace    : TGUID = '{4fa35693-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMLight   : TGUID = '{4fa35694-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMTexture : TGUID = '{4fa35695-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMWrap    : TGUID = '{4fa35696-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMMaterial: TGUID = '{4fa35697-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMAnimation:
                             TGUID = '{4fa35698-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMAnimationSet:
                             TGUID = '{4fa35699-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMUserVisual:
                             TGUID = '{4fa3569a-623f-11cf-ac4a-0000c03825a1}';
  CLSID_CDirect3DRMShadow  : TGUID = '{4fa3569b-623f-11cf-ac4a-0000c03825a1}';

(*
 * Direct3DRM Object interfaces
 *)

  IID_IDirect3DRMObject       : TGUID = '{eb16cb00-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMDevice       : TGUID = '{e9e19280-6e05-11cf-ac4a-0000c03825a1}';
  IID_IDirect3DRMViewport     : TGUID = '{eb16cb02-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMFrame        : TGUID = '{eb16cb03-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMVisual       : TGUID = '{eb16cb04-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMMesh         : TGUID = '{a3a80d01-6e12-11cf-ac4a-0000c03825a1}';
  IID_IDirect3DRMMeshBuilder  : TGUID = '{a3a80d02-6e12-11cf-ac4a-0000c03825a1}';
  IID_IDirect3DRMFace         : TGUID = '{eb16cb07-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMLight        : TGUID = '{eb16cb08-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMTexture      : TGUID = '{eb16cb09-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMWrap         : TGUID = '{eb16cb0a-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMMaterial     : TGUID = '{eb16cb0b-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMAnimation    : TGUID = '{eb16cb0d-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMAnimationSet : TGUID = '{eb16cb0e-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMDeviceArray  : TGUID = '{eb16cb10-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMViewportArray: TGUID = '{eb16cb11-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMFrameArray   : TGUID = '{eb16cb12-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMVisualArray  : TGUID = '{eb16cb13-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMLightArray   : TGUID = '{eb16cb14-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMPickedArray  : TGUID = '{eb16cb16-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMFaceArray    : TGUID = '{eb16cb17-d271-11ce-ac48-0000c03825a1}';
  IID_IDirect3DRMUserVisual   : TGUID = '{59163de0-6d43-11cf-ac4a-0000c03825a1}';
  IID_IDirect3DRMShadow       : TGUID = '{af359780-6ba3-11cf-ac4a-0000c03825a1}';

type
  IDirect3DRMObject = interface;
  IDirect3DRMDevice = interface;
  IDirect3DRMViewport = interface;
  IDirect3DRMFrame = interface;
  IDirect3DRMVisual = interface;
  IDirect3DRMMesh = interface;
  IDirect3DRMMeshBuilder = interface;
  IDirect3DRMFace = interface;
  IDirect3DRMLight = interface;
  IDirect3DRMTexture = interface;
  IDirect3DRMWrap = interface;
  IDirect3DRMMaterial = interface;
  IDirect3DRMAnimation = interface;
  IDirect3DRMAnimationSet = interface;
  IDirect3DRMUserVisual = interface;
  IDirect3DRMShadow = interface;
  IDirect3DRMArray = interface;
  IDirect3DRMDeviceArray = interface;
  IDirect3DRMFaceArray = interface;
  IDirect3DRMViewportArray = interface;
  IDirect3DRMFrameArray = interface;
  IDirect3DRMVisualArray = interface;
  IDirect3DRMPickedArray = interface;
  IDirect3DRMLightArray = interface;

  /////////////////Corrected ///////////////////////////////////////////////
  TD3DRMOBJECTCALLBACK = procedure ( lpD3DRMobj: IDirect3DRMObject ;
      lpArg: Pointer ) ; CDECL;

  TD3DRMFRAMEMOVECALLBACK = procedure ( lpD3DRMFrame: IDirect3DRMFrame ;
      lpArg: Pointer ; delta: TD3DVALUE ) ; CDECL;

  TD3DRMUPDATECALLBACK = procedure ( lpobj: IDirect3DRMDevice ; lpArg: Pointer ;
      iRectCount: Integer ; d3dRectUpdate: LPD3DRECT ) ; CDECL;

  TD3DRMUSERVISUALCALLBACK = function ( lpD3DRMUV: IDirect3DRMUserVisual ;
      lpArg: Pointer ; lpD3DRMUVreason: TD3DRMUSERVISUALREASON ;
      lpD3DRMDev: IDirect3DRMDevice ;
      lpD3DRMview: IDirect3DRMViewport ): Integer ; CDECL;

  TD3DRMLOADTEXTURECALLBACK = function ( tex_name: PChar ; lpArg: Pointer ;
      lpD3DRMTex: IDirect3DRMTexture ): HRESULT ;  CDECL;

  TD3DRMLOADCALLBACK = procedure ( lpObject: IDirect3DRMObject ;
      ObjectGuid: TGUID ; lpArg: Pointer ) ; CDECL;

  /////////////////////////////////////////////////////////////////////////////

  TD3DRMPICKDESC = record
    ulFaceIdx: LongInt ;
    lGroupIdx: LongInt ;
    vPosition: TD3DVECTOR ;
  end ;
  PD3DRMPICKDESC = ^TD3DRMPICKDESC ;

(*
 * Base interface
 *)
  IDirect3DRMObject = interface ( IUnknown )
     ['{eb16cb00-d271-11ce-ac48-0000c03825a1}']

    (* The methods for IDirect3DRMObject *)
     function Clone ( pUnkOuter: IUnknown ; riid: TGUID ;
        var ppvObj: Pointer ): HRESULT ; stdcall;
     function AddDestroyCallback ( lpCallback: TD3DRMOBJECTCALLBACK ;
        lpArg: Pointer ): HRESULT ; stdcall;
     function DeleteDestroyCallback ( d3drmObjProc: TD3DRMOBJECTCALLBACK ;
        lpArg: Pointer ): HRESULT ; stdcall;
     function SetAppData ( ulData: DWORD ): HRESULT ; stdcall;
     function GetAppData: DWORD ; stdcall;
     function SetName ( lpName: PChar ): HRESULT ; stdcall;
     function GetName ( var lpdwSize: DWORD ; lpName: PChar ): HRESULT ;
        stdcall;
     function GetinterfaceName ( var lpdwSize: DWORD ; lpName: PChar ): HRESULT ;
        stdcall;
  end ;

  IDirect3DRMVisual = interface ( IDirect3DRMObject )
   ['{eb16cb04-d271-11ce-ac48-0000c03825a1}']
  end;

  IDirect3DRMDevice = interface ( IDirect3DRMObject )
    ['{e9e19280-6e05-11cf-ac4a-0000c03825a1}']
    
    (* IDirect3DRMDevice methods *)
    function Init ( width: LongInt ; height: LongInt ): HRESULT ; stdcall;
    function InitFromD3D ( lpD3D: IDirect3D ; lpD3DIMDev: IDirect3DDevice ):
        HRESULT ; stdcall;
    function InitFromClipper ( lpDDClipper: IDirectDrawClipper ; lpGUID: PGUID ;
        width: Integer ; height: Integer ): HRESULT ; stdcall;

    function Update: HRESULT ; stdcall;
    function AddUpdateCallback ( d3drmUpdateProc: TD3DRMUPDATECALLBACK ;
        arg: Pointer ): HRESULT ; stdcall;
    function DeleteUpdateCallback ( d3drmUpdateProc: TD3DRMUPDATECALLBACK ;
        arg: Pointer ): HRESULT ; stdcall;
    function SetBufferCount ( dwCount: DWORD ): HRESULT ; stdcall;
    function GetBufferCount: DWORD ; stdcall;

    function SetDither ( bDither: BOOL ): HRESULT ; stdcall;
    function SetShades ( ulShades: DWORD ): HRESULT ; stdcall;
    function SetQuality ( rqQuality: TD3DRMRENDERQUALITY ): HRESULT ; stdcall;
    function SetTextureQuality ( tqTextureQuality: TD3DRMTEXTUREQUALITY ):
        HRESULT ; stdcall;

    function GetViewports ( var lplpViewports: IDirect3DRMViewportArray ):
        HRESULT ; stdcall;

    function GetDither: BOOL ; stdcall;
    function GetShades: DWORD ; stdcall;
    function GetHeight: DWORD ; stdcall;
    function GetWidth: DWORD ; stdcall;
    function GetTrianglesDrawn: DWORD ; stdcall;
    function GetWireframeOptions: DWORD ; stdcall;
    function GetQuality: TD3DRMRENDERQUALITY ; stdcall;
    function GetColorModel: TD3DCOLORMODEL ; stdcall;
    function GetTextureQuality: TD3DRMTEXTUREQUALITY ; stdcall;
    function GetDirect3DDevice ( var lplpD3DDevice: IDirect3DDevice ):
        HRESULT ; stdcall;
  end ;

  IDirect3DRMViewport = interface ( IDirect3DRMObject )
    ['{eb16cb02-d271-11ce-ac48-0000c03825a1}']
    
    (* IDirect3DRMViewport methods *)
    function Init ( lpD3DRMDevice: IDirect3DRMDevice ;
        lpD3DRMFrameCamera: IDirect3DRMFrame ; xpos, ypos,
        width, height: DWORD ): HRESULT ; stdcall;
    function Clear: HRESULT ; stdcall;
    function Render ( lpD3DRMFrame: IDirect3DRMFrame ): HRESULT ; stdcall;

    function SetFront ( rvFront: TD3DVALUE ): HRESULT ; stdcall;
    function SetBack ( rvBack: TD3DVALUE ): HRESULT ; stdcall;
    function SetField ( rvField: TD3DVALUE ): HRESULT ; stdcall;
    function SetUniformScaling ( bScale: BOOL ): HRESULT ; stdcall;
    function SetCamera ( lpCamera: IDirect3DRMFrame ): HRESULT ; stdcall;
    function SetProjection ( rptType: TD3DRMPROJECTIONTYPE ): HRESULT ; stdcall;
    function Transform ( var lprvDst: TD3DRMVECTOR4D ; var lprvSrc: TD3DVECTOR ):
        HRESULT ; stdcall;
    function InverseTransform ( var lprvDst: TD3DVECTOR ;
        var lprvSrc: TD3DRMVECTOR4D ): HRESULT ; stdcall;
    function Configure ( lX, lY: LongInt ; dwWidth, dwHeight: DWORD ): HRESULT ;
        stdcall;
    function ForceUpdate ( dwX1, dwY1, dwX2, dwY2: DWORD ): HRESULT ; stdcall;
    function SetPlane ( rvLeft, rvRight, rvBottom, rvTop: TD3DVALUE ): HRESULT ;
        stdcall;

    function GetCamera ( var lpCamera: IDirect3DRMFrame ): HRESULT ; stdcall;

    //Corrected
    function GetDevice ( var lpD3DRMDevice: IDirect3DRMDevice ): HRESULT ; stdcall;

    function GetPlane ( var lpd3dvLeft, lpd3dvRight, lpd3dvBottom, lpd3dvTop:
        TD3DVALUE ): HRESULT ; stdcall;
    function Pick ( lX, lY: LongInt ; var lplpVisuals: IDirect3DRMPickedArray ):
        HRESULT ; stdcall;

    function GetUniformScaling: BOOL ; stdcall;
    function GetX: LongInt; stdcall;
    function GetY: LongInt; stdcall;
    function GetWidth: DWORD ; stdcall;
    function GetHeight: DWORD ; stdcall;
    function GetField: TD3DVALUE ; stdcall;
    function GetBack: TD3DVALUE ; stdcall;
    function GetFront: TD3DVALUE ; stdcall;
    function GetProjection: TD3DRMPROJECTIONTYPE ; stdcall;
    function GetDirect3DViewport ( var lplpD3DViewport: IDirect3DViewport ):
        HRESULT ; stdcall;
  end ;

  IDirect3DRMFrame = interface ( IDirect3DRMVisual )
    ['{eb16cb03-d271-11ce-ac48-0000c03825a1}']
    
    (* IDirect3DRMFrame methods *)
    function AddChild ( lpD3DRMFrameChild: IDirect3DRMFrame ): HRESULT ;
        stdcall;
    function AddLight ( lpD3DRMLight: IDirect3DRMLight ): HRESULT ; stdcall;
    function AddMoveCallback ( d3drmFMC: TD3DRMFRAMEMOVECALLBACK ;
        lpArg: Pointer ): HRESULT ; stdcall;
    function AddTransform ( rctCombine: TD3DRMCOMBINETYPE ;
        rmMatrix: TD3DRMMATRIX4D ): HRESULT ; stdcall;
    function AddTranslation ( rctCombine: TD3DRMCOMBINETYPE ; rvX, rvY, rvZ:
        TD3DVALUE ): HRESULT ; stdcall;
    function AddScale ( rctCombine: TD3DRMCOMBINETYPE ; rvX, rvY, rvZ: TD3DVALUE ):
        HRESULT ; stdcall;
    function AddRotation ( rctCombine: TD3DRMCOMBINETYPE ; rvX, rvY, rvZ,
        rvTheta: TD3DVALUE ): HRESULT ; stdcall;
    function AddVisual ( lpD3DRMVisual: IDirect3DRMVisual ): HRESULT ; stdcall;
    function GetChildren ( var lplpChildren: IDirect3DRMFrameArray ): HRESULT ;
        stdcall;
    function GetColor: TD3DCOLOR ; stdcall;
    function GetLights ( var lplpLights: IDirect3DRMLightArray ): HRESULT ;
        stdcall;
    function GetMaterialMode: TD3DRMMATERIALMODE ; stdcall;
    function GetParent ( var lplpParent: IDirect3DRMFrame ): HRESULT ; stdcall;
    function GetPosition ( lpRef: IDirect3DRMFrame ; var lprvPos: TD3DVECTOR ):
        HRESULT ; stdcall;
    function GetRotation ( lpRef: IDirect3DRMFrame ; var lprvAxis: TD3DVECTOR ;
        var lprvTheta: TD3DVALUE ): HRESULT ; stdcall;
    function GetScene ( var lplpRoot: IDirect3DRMFrame ): HRESULT ; stdcall;
    function GetSortMode: TD3DRMSORTMODE ; stdcall;
    function GetTexture ( var lplpTexture: IDirect3DRMTexture ): HRESULT ;
        stdcall;
    function GetTransform ( rmMatrix: TD3DRMMATRIX4D ): HRESULT ; stdcall;
    function GetVelocity ( lpRef: IDirect3DRMFrame ; var lprvVel: TD3DVECTOR ;
        fRotVel: BOOL ): HRESULT ; stdcall;
    function GetOrientation ( lpRef: IDirect3DRMFrame ; var lprvDir: TD3DVECTOR ;
        var lprvUp: TD3DVECTOR ): HRESULT ; stdcall;
    function GetVisuals ( var lplpVisuals: IDirect3DRMVisualArray ): HRESULT ;
        stdcall;
    function GetTextureTopology ( var lpU, lpV: BOOL ): HRESULT ; stdcall;
    function InverseTransform ( var lprvDst, lprvSrc: TD3DVECTOR ): HRESULT ;
        stdcall;
    function Load ( lpvObjSource: Pointer ; lpvObjID: Pointer ;
        d3drmLOFlags: TD3DRMLOADOPTIONS ; d3drmLoadTextureProc:
        TD3DRMLOADTEXTURECALLBACK ; lpArgLTP: Pointer ): HRESULT ; stdcall;
    function LookAt ( lpTarget, lpRef: IDirect3DRMFrame ;
        rfcConstraint: TD3DRMFRAMECONSTRAINT  ): HRESULT ; stdcall;
    function Move ( delta: TD3DVALUE ): HRESULT ; stdcall;
    function DeleteChild ( lpChild: IDirect3DRMFrame ): HRESULT ; stdcall;
    function DeleteLight ( lpD3DRMLight: IDirect3DRMLight ): HRESULT ; stdcall;
    function DeleteMoveCallback ( d3drmFMC: TD3DRMFRAMEMOVECALLBACK ;
        lpArg: Pointer): HRESULT ; stdcall;
    function DeleteVisual ( lpD3DRMVisual: IDirect3DRMVisual ): HRESULT ;
        stdcall;
    function GetSceneBackground: TD3DCOLOR ; stdcall;
    function GetSceneBackgroundDepth ( var lplpDDSurface: IDirectDrawSurface ):
        HRESULT ; stdcall;
    function GetSceneFogColor: TD3DCOLOR ; stdcall;
    function GetSceneFogEnable: BOOL ; stdcall;
    function GetSceneFogMode: TD3DRMFOGMODE ; stdcall;
    function GetSceneFogParams ( var lprvStart, lprvEnd, lprvDensity: TD3DVALUE ):
        HRESULT ; stdcall;
    function SetSceneBackground ( rcColor: TD3DCOLOR): HRESULT ; stdcall;
    function SetSceneBackgroundRGB ( rvRed, rvGreen, rvBlue: TD3DVALUE ):
        HRESULT ; stdcall;
    function SetSceneBackgroundDepth ( lpImage: IDirectDrawSurface ): HRESULT ;
        stdcall;
    function SetSceneBackgroundImage ( lpTexture: IDirect3DRMTexture ): HRESULT ;
        stdcall;
    function SetSceneFogEnable ( bEnable: BOOL ): HRESULT ; stdcall;
    function SetSceneFogColor ( rcColor: TD3DCOLOR ): HRESULT ; stdcall;
    function SetSceneFogMode ( rfMode: TD3DRMFOGMODE ): HRESULT ; stdcall;
    function SetSceneFogParams ( rvStart, rvEnd, rvDensity: TD3DVALUE ): HRESULT ;
        stdcall;
    function SetColor ( rcColor: TD3DCOLOR): HRESULT ; stdcall;
    function SetColorRGB ( rvRed, rvGreen, rvBlue: TD3DVALUE ): HRESULT ;
        stdcall;
    function GetZbufferMode: TD3DRMZBUFFERMODE ; stdcall;
    function SetMaterialMode ( rmmMode: TD3DRMMATERIALMODE): HRESULT ; stdcall;
    function SetOrientation ( lpRef: IDirect3DRMFrame ; rvDx, rvDy, rvDz, rvUx,
        rvUy, rvUz: TD3DVALUE ): HRESULT ; stdcall;
    function SetPosition ( lpRef: IDirect3DRMFrame ; rvX, rvY, rvZ: TD3DVALUE ):
        HRESULT ; stdcall;
    function SetRotation ( lpRef: IDirect3DRMFrame ; rvX, rvY, rvZ,
        rvTheta: TD3DVALUE ): HRESULT ; stdcall;
    function SetSortMode ( d3drmSM: TD3DRMSORTMODE ): HRESULT ; stdcall;
    function SetTexture ( lpD3DRMTexture: IDirect3DRMTexture ): HRESULT ;
        stdcall;
    function SetTextureTopology ( cylU, cylV: BOOL ): HRESULT ; stdcall;
    function SetVelocity ( lpRef: IDirect3DRMFrame ; rvX, rvY, rvZ: TD3DVALUE ;
        fRotVel: BOOL ): HRESULT ; stdcall;
    function SetZbufferMode ( d3drmZBM: TD3DRMZBUFFERMODE ): HRESULT ; stdcall;
    function Transform ( var lpd3dVDst, lpd3dVSrc: TD3DVECTOR ): HRESULT ; stdcall;
  end ;

  IDirect3DRMMesh = interface ( IDirect3DRMVisual )
    ['{a3a80d01-6e12-11cf-ac4a-0000c03825a1}']
    
    (* IDirect3DRMMesh methods *)
    function Scale ( sx, sy, sz: TD3DVALUE ): HRESULT ; stdcall;
    function Translate ( tx, ty, tz: TD3DVALUE ): HRESULT ; stdcall;
    function GetBox ( var lpD3DRMBox: TD3DRMBOX ): HRESULT ; stdcall;
    function AddGroup ( vCount, fCount, vPerFace: DWORD ; var fData: DWORD ;
        var returnId: TD3DRMGROUPINDEX ): HRESULT ; stdcall;
    function SetVertices ( id: TD3DRMGROUPINDEX ; index, count: DWORD ;
        var values: TD3DRMVERTEX ): HRESULT ; stdcall;
    function SetGroupColor ( id: TD3DRMGROUPINDEX ; value: TD3DCOLOR ): HRESULT ; stdcall;
    function SetGroupColorRGB ( id: TD3DRMGROUPINDEX ; red, green,
        blue: TD3DVALUE ): HRESULT ; stdcall;
    function SetGroupMapping ( id: TD3DRMGROUPINDEX ;
        value: TD3DRMMAPPING ): HRESULT ; stdcall;
    function SetGroupQuality ( id: TD3DRMGROUPINDEX ;
        value: TD3DRMRENDERQUALITY ): HRESULT ; stdcall;
    function SetGroupMaterial ( id: TD3DRMGROUPINDEX ; value:
        IDirect3DRMMaterial ): HRESULT ; stdcall;
    function SetGroupTexture ( id: TD3DRMGROUPINDEX ; value: IDirect3DRMTexture ):
        HRESULT ; stdcall;

    function GetGroupCount: DWORD ; stdcall;
    function GetGroup ( id: TD3DRMGROUPINDEX ; var vCount, fCount, vPerFace,
        fDataSize, fData: DWORD ): HRESULT ; stdcall;

    //Corrected
    function GetVertices ( id: TD3DRMGROUPINDEX; index, count : DWORD;
	var returnPtr : TD3DRMVertex): HResult; stdcall;

    function GetGroupColor ( id: TD3DRMGROUPINDEX ): TD3DCOLOR ; stdcall;
    function GetGroupMapping ( id: TD3DRMGROUPINDEX ): TD3DRMMAPPING ; stdcall;
    function GetGroupQuality ( id: TD3DRMGROUPINDEX ): TD3DRMRENDERQUALITY ; stdcall;
    function GetGroupMaterial ( id: TD3DRMGROUPINDEX ;
        var returnPtr: IDirect3DRMMaterial ): HRESULT ; stdcall;
    function GetGroupTexture ( id: TD3DRMGROUPINDEX ;
        var returnPtr: IDirect3DRMTexture ): HRESULT ; stdcall;
  end ;

  IDirect3DRMShadow = interface ( IDirect3DRMVisual )
    ['{af359780-6ba3-11cf-ac4a-0000c03825a1}']
    
    (* IDirect3DRMShadow methods *)
    function Init ( lpD3DRMVisual: IDirect3DRMVisual ;
        lpD3DRMLight: IDirect3DRMLight ; px, py, pz, nx, ny, nz: TD3DVALUE ): HRESULT ; stdcall;
  end ;

  IDirect3DRMFace = interface ( IDirect3DRMObject )
     ['{eb16cb07-d271-11ce-ac48-0000c03825a1}']
     
    (* IDirect3DRMFace methods *)
     function AddVertex ( x, y, z: TD3DVALUE ): HRESULT ; stdcall;
     function AddVertexAndNormalIndexed ( vertex: DWORD ; normal: DWORD ): HRESULT ; stdcall;
     function SetColorRGB ( red, green, blue: TD3DVALUE ): HRESULT ; stdcall ;
     function SetColor ( color: TD3DCOLOR ): HRESULT ; stdcall;
     function SetTexture ( lpD3DRMTexture: IDirect3DRMTexture ): HRESULT ; stdcall;
     function SetTextureCoordinates ( vertex: DWORD ; u, v: TD3DVALUE ): HRESULT ; stdcall;
     function SetMaterial ( lpMat: IDirect3DRMMaterial ): HRESULT ; stdcall ;
     function SetTextureTopology ( cylU, cylV: BOOL ): HRESULT ; stdcall ;

     function GetVertex ( index: DWORD ; var lpPosition: TD3DVECTOR ;
        var lpNormal: TD3DVECTOR ): HRESULT ; stdcall;

     function GetVertices ( var lpdwVertexCount: DWORD ;
        var lpPosition, lpNormal: TD3DVECTOR ): HRESULT ; stdcall;

     function GetTextureCoordinates ( index: DWORD ; var lpU, lpV: TD3DVALUE ): HRESULT ; stdcall;
     function GetTextureTopology ( var lpU, lpV: BOOL ): HRESULT ; stdcall ;
     function GetNormal ( var lpNormal: TD3DVECTOR ): HRESULT ; stdcall ;
     function GetTexture ( var lplpTexture: IDirect3DRMTexture ): HRESULT ; stdcall;

     //Corrected
     function GetMaterial ( var lpMat: IDirect3DRMMaterial ): HRESULT ; stdcall ;

     function GetVertexCount: Integer ; stdcall;
     function GetVertexIndex ( dwIndex: DWORD ): Integer ; stdcall;
     function GetTextureCoordinateIndex ( dwIndex: DWORD ): Integer ; stdcall;
     function GetColor: TD3DCOLOR ; stdcall;
  end ;

  IDirect3DRMMeshBuilder = interface ( IDirect3DRMVisual )
    ['{a3a80d02-6e12-11cf-ac4a-0000c03825a1}']
    
    (* IDirect3DRMMeshBuilder methods *)
    function Load ( lpvObjSource, lpvObjID: Pointer ; d3drmLOFlags:
        TD3DRMLOADOPTIONS ; d3drmLoadTextureProc: TD3DRMLOADTEXTURECALLBACK ;
        lpvArg: Pointer ): HRESULT ; stdcall;
    function Save ( lpFilename: PChar ; d3drmXOFFormat: TD3DRMXOFFORMAT ;
        d3drmSOContents: TD3DRMSAVEOPTIONS ): HRESULT ; stdcall;
    function Scale ( sx, sy, sz: TD3DVALUE ): HRESULT ; stdcall;
    function Translate ( tx, ty, tz: TD3DVALUE ): HRESULT ; stdcall;
    function SetColorSource ( source: TD3DRMCOLORSOURCE ): HRESULT ; stdcall ;
    function GetBox ( var lpD3DRMBox: TD3DRMBOX ): HRESULT ; stdcall;
    function GenerateNormals: HRESULT ; stdcall;
    function GetColorSource: TD3DRMCOLORSOURCE ; stdcall;

    function AddMesh ( lpD3DRMMesh: IDirect3DRMMesh ): HRESULT ; stdcall ;
    function AddMeshBuilder ( lpD3DRMMeshBuild: IDirect3DRMMeshBuilder ):
        HRESULT ; stdcall;
    function AddFrame ( lpD3DRMFrame: IDirect3DRMFrame ): HRESULT ; stdcall ;
    function AddFace ( lpD3DRMFace: IDirect3DRMFace ): HRESULT ; stdcall ;
    function AddFaces ( dwVertexCount: DWORD ; var lpD3DVertices: TD3DVECTOR ;
        normalCount: DWORD ; var lpNormals: TD3DVECTOR ; var lpFaceData: DWORD ;
        var lplpD3DRMFaceArray: IDirect3DRMFaceArray ): HRESULT ; stdcall ;
    function ReserveSpace ( vertexCount, normalCount, faceCount: DWORD ):
        HRESULT ; stdcall;
    function SetColorRGB ( red, green, blue: TD3DVALUE ): HRESULT ; stdcall ;
    function SetColor ( color: TD3DCOLOR ): HRESULT ; stdcall;
    function SetTexture ( lpD3DRMTexture: IDirect3DRMTexture ): HRESULT ;
        stdcall;
    function SetMaterial ( lpIDirect3DRMmaterial: IDirect3DRMMaterial ):
        HRESULT ; stdcall;
    function SetTextureTopology ( cylU, cylV: BOOL ): HRESULT ; stdcall ;
    function SetQuality ( quality: TD3DRMRENDERQUALITY): HRESULT ; stdcall ;
    function SetPerspective ( perspective: BOOL ): HRESULT ; stdcall ;
    function SetVertex ( index: DWORD ; x, y, z: TD3DVALUE ): HRESULT ; stdcall ;
    function SetNormal ( index: DWORD ; x, y, z: TD3DVALUE ): HRESULT ; stdcall ;
    function SetTextureCoordinates ( index: DWORD ; u, v: TD3DVALUE ): HRESULT ;
        stdcall;
    function SetVertexColor ( index: DWORD ; color: TD3DCOLOR ): HRESULT ;
        stdcall;
    function SetVertexColorRGB ( index: DWORD ; red, green, blue: TD3DVALUE ):
        HRESULT ; stdcall;

    function GetFaces ( var lplpD3DRMFaceArray: IDirect3DRMFaceArray ): HRESULT ;
        stdcall;

    //Corrected
    function GetVertices ( var vcount: DWORD ; var vertices : TD3DVECTOR;
        var ncount : DWORD;
        var normals : TD3DVECTOR;
        var face_data_size, face_data : DWORD) : HRESULT ; stdcall;

    //Corrected - missed by Blake Stone
    function GetTextureCoordinates(index : DWORD; var u, v : TD3DVALUE) : HRESULT; stdcall;


    function AddVertex ( x, y, z: TD3DVALUE ): Integer ; stdcall;
    function AddNormal ( x, y, z: TD3DVALUE ): Integer ; stdcall;
    function CreateFace ( var lplpd3drmFace: IDirect3DRMFace ): HRESULT ; stdcall;
    function GetQuality: TD3DRMRENDERQUALITY ; stdcall;
    function GetPerspective: BOOL ; stdcall;
    function GetFaceCount: Integer ; stdcall;
    function GetVertexCount: Integer ; stdcall;
    function GetVertexColor ( index: DWORD ): TD3DCOLOR ; stdcall;

    function CreateMesh ( var lplpD3DRMMesh: IDirect3DRMMesh ): HRESULT ; stdcall;
  end ;

  IDirect3DRMLight = interface ( IDirect3DRMObject )
    ['{eb16cb08-d271-11ce-ac48-0000c03825a1}']
    
    (* IDirect3DRMLight methods *)
    function SetType ( d3drmtType: TD3DRMLIGHTTYPE ): HRESULT ; stdcall ;
    function SetColor ( rcColor: TD3DCOLOR ): HRESULT ; stdcall;
    function SetColorRGB ( rvRed, rvGreen, rvBlue: TD3DVALUE ): HRESULT ; stdcall;
    function SetRange ( rvRange: TD3DVALUE ): HRESULT ; stdcall;
    function SetUmbra ( rvAngle: TD3DVALUE ): HRESULT ; stdcall;
    function SetPenumbra ( rvAngle: TD3DVALUE ): HRESULT ; stdcall;
    function SetConstantAttenuation ( rvAtt: TD3DVALUE ): HRESULT ; stdcall ;
    function SetLinearAttenuation ( rvAtt: TD3DVALUE ): HRESULT ; stdcall ;
    function SetQuadraticAttenuation ( rvAtt: TD3DVALUE ): HRESULT ; stdcall ;

    function GetRange: TD3DVALUE ; stdcall;
    function GetUmbra: TD3DVALUE ; stdcall;
    function GetPenumbra: TD3DVALUE ; stdcall;
    function GetConstantAttenuation: TD3DVALUE ; stdcall;
    function GetLinearAttenuation: TD3DVALUE ; stdcall;
    function GetQuadraticAttenuation: TD3DVALUE ; stdcall;
    function GetColor: TD3DCOLOR ; stdcall;
    function GetType: TD3DRMLIGHTTYPE ; stdcall;

    function SetEnableFrame ( lpEnableFrame: IDirect3DRMFrame ): HRESULT ; stdcall;
    function GetEnableFrame ( var lplpEnableFrame: IDirect3DRMFrame ): HRESULT ; stdcall;
  end ;

  IDirect3DRMTexture = interface ( IDirect3DRMVisual )
    ['{eb16cb09-d271-11ce-ac48-0000c03825a1}']
    
    (* IDirect3DRMTexture methods *)
    function InitFromFile ( filename: PChar ): HRESULT ; stdcall;
    function InitFromSurface ( lpDDS: IDirectDrawSurface ): HRESULT ; stdcall ;
    function InitFromResource ( rs: HRSRC ): HRESULT ; stdcall ;
    function Changed ( bPixels, bPalette: BOOL ): HRESULT ; stdcall ;

    function SetColors ( ulColors: DWORD ): HRESULT ; stdcall;
    function SetShades ( ulShades: DWORD ): HRESULT ; stdcall;
    function SetDecalSize ( rvWidth, rvHeight: TD3DVALUE ): HRESULT ; stdcall ;
    function SetDecalOrigin ( lX, lY: LongInt ): HRESULT ; stdcall;
    function SetDecalScale ( dwScale: DWORD ): HRESULT ; stdcall;
    function SetDecalTransparency ( bTransp: BOOL ): HRESULT ; stdcall ;
    function SetDecalTransparentColor ( rcTransp: TD3DCOLOR ): HRESULT ;  stdcall;
    function GetDecalSize ( var lprvWidth, lprvHeight: TD3DVALUE ): HRESULT ;  stdcall;
    function GetDecalOrigin ( var lplX, lplY: LongInt ): HRESULT ; stdcall ;

    function GetImage: LPD3DRMIMAGE ; stdcall;
    function GetShades: DWORD ; stdcall;
    function GetColors: DWORD ; stdcall;
    function GetDecalScale: DWORD ; stdcall;
    function GetDecalTransparency: BOOL ; stdcall;
    function GetDecalTransparentColor: TD3DCOLOR ; stdcall;
  end ;

  IDirect3DRMWrap = interface ( IDirect3DRMObject )
    ['{eb16cb0a-d271-11ce-ac48-0000c03825a1}']
    
    (* IDirect3DRMWrap methods *)
    function Init ( d3drmwt: TD3DRMWRAPTYPE ; lpd3drmfRef: IDirect3DRMFrame ;
        ox, oy, oz, dx, dy, dz, ux, uy, uz, ou, ov, su, sv: TD3DVALUE ):
        HRESULT ; stdcall;
    function Apply ( lpObject: IDirect3DRMObject ): HRESULT ; stdcall ;
    function ApplyRelative ( frame: IDirect3DRMFrame ; mesh: IDirect3DRMObject ):
        HRESULT ; stdcall;
  end ;

  IDirect3DRMMaterial = interface ( IDirect3DRMObject )
    ['{eb16cb0b-d271-11ce-ac48-0000c03825a1}']
    
    (* IDirect3DRMMaterial methods *)
    function SetPower ( rvPower: TD3DVALUE ): HRESULT ; stdcall ;
    function SetSpecular ( r, g, b: TD3DVALUE ): HRESULT ; stdcall ;
    function SetEmissive ( r, g, b: TD3DVALUE ): HRESULT ; stdcall ;

    function GetPower: TD3DVALUE ; stdcall;
    function GetSpecular ( var lpr, lpg, lpb: TD3DVALUE ): HRESULT ; stdcall ;
    function GetEmissive ( var lpr, lpg, lpb: TD3DVALUE ): HRESULT ; stdcall ;
  end ;

  IDirect3DRMAnimation = interface ( IDirect3DRMObject )
    ['{eb16cb0d-d271-11ce-ac48-0000c03825a1}']

    (* IDirect3DRMAnimation methods *)
    function SetOptions ( d3drmanimFlags: TD3DRMANIMATIONOPTIONS ): HRESULT ; stdcall;
    function AddRotateKey ( rvTime: TD3DVALUE ; var rqQuat: TD3DRMQUATERNION ): HRESULT ; stdcall;
    function AddPositionKey ( rvTime, rvX, rvY, rvZ: TD3DVALUE ): HRESULT ; stdcall;
    function AddScaleKey ( time, x, y, z: TD3DVALUE ): HRESULT ; stdcall ;
    function DeleteKey ( time: TD3DVALUE ): HRESULT ; stdcall;
    function SetFrame ( lpD3DRMFrame: IDirect3DRMFrame ): HRESULT ; stdcall ;
    function SetTime ( rvTime: TD3DVALUE ): HRESULT ; stdcall;
    function GetOptions: TD3DRMANIMATIONOPTIONS ; stdcall;

  end ;

  IDirect3DRMAnimationSet = interface ( IDirect3DRMObject )
    ['{eb16cb0e-d271-11ce-ac48-0000c03825a1}']
    
    (* IDirect3DRMAnimationSet methods *)
    function AddAnimation ( lpD3DRMAnimation: IDirect3DRMAnimation ): HRESULT ;  stdcall;
    function Load ( lpvObjSource, lpvObjID: Pointer ;
        d3drmLOFlags: TD3DRMLOADOPTIONS ;
        d3drmLoadTextureProc: TD3DRMLOADTEXTURECALLBACK ; lpArgLTP: Pointer ;
        lpParentFrame: IDirect3DRMFrame ): HRESULT ; stdcall;
    function DeleteAnimation ( lpD3DRMAnimation: IDirect3DRMAnimation ):
        HRESULT ; stdcall;
    function SetTime ( rvTime: TD3DVALUE ): HRESULT ; stdcall;
  end ;

  IDirect3DRMUserVisual = interface ( IDirect3DRMVisual )
    ['{59163de0-6d43-11cf-ac4a-0000c03825a1}']

    (* IDirect3DRMUserVisual methods *)
    function Init ( d3drmUVProc: TD3DRMUSERVISUALCALLBACK ; lpArg: Pointer ):
        HRESULT ; stdcall;
  end ;

  IDirect3DRMArray = interface ( IUnknown )
    function GetSize: DWORD ; stdcall;
    (* No GetElement method as it would get overloaded
     * in derived interfacees, and overloading is
     * a no-no in COM
     *)
  end ;

  IDirect3DRMDeviceArray = interface ( IDirect3DRMArray )
   ['{eb16cb10-d271-11ce-ac48-0000c03825a1}']
   
    function GetElement ( index: DWORD ; var lplpD3DRMDevice:
        IDirect3DRMDevice ): HRESULT ; stdcall;
  end ;

  IDirect3DRMFrameArray = interface ( IDirect3DRMArray )
    ['{eb16cb12-d271-11ce-ac48-0000c03825a1}']
    
    function GetElement ( index: DWORD ; var lplpD3DRMFrame: IDirect3DRMFrame ):
        HRESULT ; stdcall;
  end ;

  IDirect3DRMViewportArray = interface ( IDirect3DRMArray )
    ['{eb16cb11-d271-11ce-ac48-0000c03825a1}']
    
    function GetElement ( index: DWORD ; var lplpD3DRMViewport:
        IDirect3DRMViewport): HRESULT ; stdcall;
  end ;

  IDirect3DRMVisualArray = interface ( IDirect3DRMArray )
    ['{eb16cb13-d271-11ce-ac48-0000c03825a1}']
    
    function GetElement ( index: DWORD ; var lplpD3DRMVisual:
        IDirect3DRMVisual ): HRESULT ; stdcall;
  end ;

  IDirect3DRMPickedArray = interface ( IDirect3DRMArray )
    ['{eb16cb16-d271-11ce-ac48-0000c03825a1}']
    
    function GetPick ( index: DWORD ; var lplpVisual: IDirect3DRMVisual ;
        var lplpFrameArray: IDirect3DRMFrameArray ;
        var lpD3DRMPickDesc: TD3DRMPICKDESC ): HRESULT ; stdcall;
  end ;

  IDirect3DRMLightArray = interface ( IDirect3DRMArray )
    ['{eb16cb14-d271-11ce-ac48-0000c03825a1}']

    function GetElement ( index: DWORD ; var lplpD3DRMLight: IDirect3DRMLight ):
        HRESULT ; stdcall;
  end ;

  IDirect3DRMFaceArray = interface ( IDirect3DRMArray )
    ['{eb16cb17-d271-11ce-ac48-0000c03825a1}']
    
    function GetElement ( index: DWORD ; var lplpD3DRMFace: IDirect3DRMFace ):
        HRESULT ; stdcall;
  end ;

implementation

end.

