unit IDsound ;

interface

uses Windows, MMSystem,SysUtils,ID3dtypes;


(*==========================================================================;
 *
 *  Copyright (C) 1995,1996 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       dsound.h
 *  Content:    DirectSound include file
 *
 *  DirectX 3 Delphi adaptation by Blake Stone
 *
 *    EMail:     bstone@dkw.com
 *    Home Page: http://www.dkw.com/bstone
 *
 *  DirectX 3 Delphi 3 adaptation by Paolo Rainone 1997
 *
 *    EMail:     rainone@programmers.net
 ***************************************************************************)

{$Z4}
{$A+}

const
  // Direct Sound Component GUID    {47D4D946-62E8-11cf-93BC-444553540000}
  CLSID_DirectSound: TGUID = '{47D4D946-62E8-11cf-93BC-444553540000}';


  // DirectSound 279afa83-4981-11ce-a521-0020af0be560
  IID_IDirectSound: TGUID = '{279afa83-4981-11ce-a521-0020af0be560}';

  // DirectSoundBuffer 279afa85-4981-11ce-a521-0020af0be560
  IID_IDirectSoundBuffer: TGUID = '{279afa85-4981-11ce-a521-0020af0be560}';

  //DirectSound3DListener 279afa84-4981-11ce-a521-0020af0be560
  IID_IDirectSound3DListener: TGUID = '{279AFA84-4981-11CE-A521-0020AF0BE560}';

  //DirectSound3DBuffer 279afa86-4981-11ce-a521-0020af0be560
  IID_IDirectSound3DBuffer: TGUID = '{279afa86-4981-11ce-a521-0020af0be560}';

//==========================================================================;
//
//                            Structures...
//
//==========================================================================;

type
  IDirectSound = Interface ;
  IDirectSoundBuffer = Interface ;
  IDirectSound3DListener = Interface ;
  IDirectSound3DBuffer = Interface ;

 
  TDSCAPS = record
    dwSize: DWORD ;
    dwFlags: DWORD ;
    dwMinSecondarySampleRate: DWORD ;
    dwMaxSecondarySampleRate: DWORD ;
    dwPrimaryBuffers: DWORD ;
    dwMaxHwMixingAllBuffers: DWORD ;
    dwMaxHwMixingStaticBuffers: DWORD ;
    dwMaxHwMixingStreamingBuffers: DWORD ;
    dwFreeHwMixingAllBuffers: DWORD ;
    dwFreeHwMixingStaticBuffers: DWORD ;
    dwFreeHwMixingStreamingBuffers: DWORD ;
    dwMaxHw3DAllBuffers: DWORD ;
    dwMaxHw3DStaticBuffers: DWORD ;
    dwMaxHw3DStreamingBuffers: DWORD ;
    dwFreeHw3DAllBuffers: DWORD ;
    dwFreeHw3DStaticBuffers: DWORD ;
    dwFreeHw3DStreamingBuffers: DWORD ;
    dwTotalHwMemBytes: DWORD ;
    dwFreeHwMemBytes: DWORD ;
    dwMaxContigFreeHwMemBytes: DWORD ;
    dwUnlockTransferRateHwBuffers: DWORD ;
    dwPlayCpuOverheadSwBuffers: DWORD ;
    dwReserved1: DWORD ;
    dwReserved2: DWORD ;
  end ;
  PDSCAPS = ^TDSCAPS ;

  TDSBCAPS = record
    dwSize: DWORD ;
    dwFlags: DWORD ;
    dwBufferBytes: DWORD ;
    dwUnlockTransferRate: DWORD ;
    dwPlayCpuOverhead: DWORD ;
  end ;
  PDSBCAPS = ^TDSBCAPS ;

  TDSBUFFERDESC = record
    dwSize: DWORD ;
    dwFlags: DWORD ;
    dwBufferBytes: DWORD ;
    dwReserved: DWORD ;
    lpwfxFormat: PWaveFormatEx ;
  end ;
  PDSBUFFERDESC = ^TDSBUFFERDESC ;

  TDS3DBUFFER = record
    dwSize: DWORD ;
    vPosition: TD3DVECTOR ;
    vVelocity: TD3DVECTOR ;
    dwInsideConeAngle: DWORD ;
    dwOutsideConeAngle: DWORD ;
    vConeOrientation: TD3DVECTOR ;
    lConeOutsideVolume: longint ;
    flMinDistance: TD3DVALUE ;
    flMaxDistance: TD3DVALUE ;
    dwMode: DWORD ;
  end ;
  PDS3DBUFFER = ^TDS3DBUFFER ;

  TDS3DLISTENER = record
    dwSize: DWORD ;
    vPosition: TD3DVECTOR ;
    vVelocity: TD3DVECTOR ;
    vOrientFront: TD3DVECTOR ;
    vOrientTop: TD3DVECTOR ;
    flDistanceFactor: TD3DVALUE ;
    flRolloffFactor: TD3DVALUE ;
    flDopplerFactor: TD3DVALUE ;
  end ;
  PDS3DLISTENER = ^TDS3DLISTENER ;


 IDirectSound = interface ( IUnknown )
    ['{279afa83-4981-11ce-a521-0020af0be560}']
    (*** IDirectSound methods ***)
    function CreateSoundBuffer ( const lpDSBufferDesc: TDSBUFFERDESC ;
        var lplpDirectSoundBuffer: IDirectSoundBuffer ;
        pUnkOuter: IUnknown ): HRESULT ; stdcall;
    function GetCaps ( const lpDSCaps: TDSCAPS ): HRESULT ; stdcall;
    function DuplicateSoundBuffer ( lpDsbOriginal: IDirectSoundBuffer ;
         var lplpDsbDuplicate: IDirectSoundBuffer ): HRESULT ; stdcall;
    function SetCooperativeLevel ( hWnd: HWND ; dwFlags: DWORD ): HRESULT ; stdcall;
    function Compact: HRESULT ; stdcall;
    function GetSpeakerConfig ( var lpdwSpeakerConfig: DWORD ): HRESULT ; stdcall;
    function SetSpeakerConfig ( dwSpeakerConfig: DWORD ): HRESULT ; stdcall;
    function Initialize ( lpGuid: PGUID ): HRESULT ; stdcall;
  end ;

//
// IDirectSoundBuffer
//

  IDirectSoundBuffer = interface ( IUnknown )
    ['{279afa85-4981-11ce-a521-0020af0be560}']
    (*** IDirectSoundBuffer methods ***)
    function GetCaps ( const lpDSBufferCaps: TDSBCAPS ): HRESULT ; stdcall;
    function GetCurrentPosition ( var dwCurrentPlayCursor: DWORD ;
        var lpdwCurrentWriteCursor: DWORD ): HRESULT ; stdcall ;
    function GetFormat ( const lpwfxFormat: TWaveFormatEx ;
        dwSizeAllocated: DWORD ; var lpdwSizeWritten: DWORD ): HRESULT ;
        stdcall;
    function GetVolume ( var lplVolume: LongInt ): HRESULT ; stdcall ;
    function GetPan ( var lplPan: LongInt ): HRESULT ; stdcall ;
    function GetFrequency ( var lpdwFrequency: DWORD ): HRESULT ; stdcall;
    function GetStatus ( var lpdwStatus: DWORD ): HRESULT ; stdcall;
    function Initialize ( lpDirectSound: IDirectSound ;
        const lpDSBufferDesc: TDSBUFFERDESC  ): HRESULT ; stdcall ;
    function Lock ( dwWriteCursor: DWORD ; dwWriteBytes: DWORD ;
        var lplpvAudioPtr1: Pointer ; var lpdwAudioBytes1: DWORD ;
        var lplpvAudioPtr2: Pointer ; var lpdwAudioBytes2: DWORD ;
        dwFlags: DWORD ): HRESULT ; stdcall;
    function Play ( dwReserved1, dwReserved2, dwFlags: DWORD ): HRESULT ; stdcall;
    function SetCurrentPosition ( dwNewPosition: DWORD ): HRESULT ; stdcall;
    function SetFormat ( const lpfxFormat: TWaveFormatEx ): HRESULT ; stdcall ;
    function SetVolume ( lVolume: LongInt ): HRESULT ; stdcall ;
    function SetPan ( lPan: LongInt ): HRESULT ; stdcall;
    function SetFrequency ( dwFrequency: DWORD ): HRESULT ; stdcall ;
    function Stop: HRESULT ; stdcall;
    function Unlock ( lpvAudioPtr1: Pointer ; dwAudioBytes1: DWORD ;
        lpvAudioPtr2: Pointer ; dwAudioBytes2: DWORD ): HRESULT ; stdcall ;
    function Restore: HRESULT ; stdcall;
  end ;

//
// IDirectSound3DListener
//

  IDirectSound3DListener = interface ( IUnknown )
    ['{279AFA84-4981-11CE-A521-0020AF0BE560}']
    (*** IDirectSound3D methods ***)
    function GetAllParameters ( var lpListener: TDS3DLISTENER ): HRESULT ; stdcall;
    function GetDistanceFactor ( var lpflDistanceFactor: TD3DVALUE ): HRESULT ; stdcall;
    function GetDopplerFactor ( var lpflDopplerFactor: TD3DVALUE ): HRESULT ; stdcall;
    function GetOrientation ( var lpvOrientFront: TD3DVECTOR ;
        var lpvOrientTop: TD3DVECTOR ): HRESULT ; stdcall;
    function GetPosition ( var lpvPosition: TD3DVECTOR ): HRESULT ; stdcall ;
    function GetRolloffFactor ( var lpflRolloffFactor: TD3DVALUE ): HRESULT ; stdcall;
    function GetVelocity ( var lpvVelocity: TD3DVECTOR): HRESULT ; stdcall ;
    function SetAllParameters ( const lpListener: TDS3DLISTENER ;
        dwApply: DWORD ): HRESULT ; stdcall;
    function SetDistanceFactor ( flDistanceFactor: TD3DVALUE ; dwApply: DWORD ):
        HRESULT ; stdcall;
    function SetDopplerFactor ( flDopplerFactor: TD3DVALUE ; dwApply: DWORD ):
        HRESULT ; stdcall;
    function SetOrientation ( xFront, yFront, zFront, xTop, yTop, zTop: TD3DVALUE ;
        dwApply: DWORD ): HRESULT ; stdcall;
    function SetPosition ( x, y, z: TD3DVALUE ; dwApply: DWORD ): HRESULT ;
        stdcall;
    function SetRolloffFactor ( flRolloffFactor: TD3DVALUE ; dwApply: DWORD ):
        HRESULT ; stdcall;
    function SetVelocity ( x, y, z: TD3DVALUE ; dwApply: DWORD ): HRESULT ;
        stdcall;
    function CommitDeferredSettings: HRESULT ; stdcall;
  end ;

//
// IDirectSound3DBuffer
//

  IDirectSound3DBuffer = interface ( IUnknown )
    ['{279afa86-4981-11ce-a521-0020af0be560}']
    (*** IDirectSoundBuffer3D methods ***)
    function GetAllParameters ( var lpDs3dBuffer: TDS3DBUFFER ): HRESULT ;
        stdcall;
    function GetConeAngles ( var lpdwInsideConeAngle: DWORD ;
        var lpdwOutsideConeAngle: DWORD ): HRESULT ; stdcall;
    function GetConeOrientation ( var lpvOrientation: TD3DVECTOR ): HRESULT ;
        stdcall;
    function GetConeOutsideVolume ( var lplConeOutsideVolume: longint ): HRESULT ;
        stdcall;
    function GetMaxDistance ( var lpflMaxDistance: TD3DVALUE ): HRESULT ;
        stdcall;
    function GetMinDistance ( var lpflMinDistance: TD3DVALUE ): HRESULT ;
        stdcall;
    function GetMode ( var lpdwMode: DWORD ): HRESULT ; stdcall ;
    function GetPosition ( var lpvPosition: TD3DVECTOR ): HRESULT ; stdcall ;
    function GetVelocity ( var lpvVelocity: TD3DVECTOR ): HRESULT ; stdcall ;
    function SetAllParameters ( const lpDs3dBuffer: TDS3DBUFFER ;
        dwApply: DWORD ): HRESULT ; stdcall;
    function SetConeAngles ( dwInsideConeAngle, dwOutsideConeAngle,
        dwApply: DWORD ): HRESULT ; stdcall;
    function SetConeOrientation ( x, y, z: TD3DVALUE ; dwApply: DWORD ): HRESULT ;
        stdcall;
    function SetConeOutsideVolume ( lConeOutsideVolume: longint ; dwApply: DWORD ):
        HRESULT ; stdcall;
    function SetMaxDistance ( flMaxDistance: TD3DVALUE ; dwApply: DWORD ):
        HRESULT ; stdcall;
    function SetMinDistance ( flMinDistance: TD3DVALUE ; dwApply: DWORD ):
        HRESULT ; stdcall;
    function SetMode ( dwMode: DWORD ; dwApply: DWORD ): HRESULT ;stdcall ;
    function SetPosition ( x, y, z: TD3DVALUE ; dwApply: DWORD ): HRESULT ;
        stdcall;
    function SetVelocity ( x, y, z: TD3DVALUE ; dwApply: DWORD ): HRESULT ;
        stdcall;
  end ;


(*
 * Return Codes
 *)

const
  DS_OK                           = 0 ;

(*
 * The call failed because resources (such as a priority level)
 *  were already being used by another caller.
 *)
  DSERR_ALLOCATED                 = $88780000 + 10 ;
(*
 * The control (vol,pan,etc.) requested by the caller is not available.
 *)
  DSERR_CONTROLUNAVAIL            = $88780000 + 30 ;
(*
 * An invalid parameter was passed to the returning function
 *)
  DSERR_INVALIDPARAM              = E_INVALIDARG ;
(*
 * This call is not valid for the current state of this object
 *)
  DSERR_INVALIDCALL               = $88780000 + 50 ;
(*
 * An undetermined error occured inside the DSound subsystem
 *)
  DSERR_GENERIC                   = E_FAIL ;
(*
 * The caller does not have the priority level required for the function to
 * succeed.
 *)
  DSERR_PRIOLEVELNEEDED           = $88780000 + 70 ;
(*
 * The DSound subsystem couldn't allocate sufficient memory to complete the
 * caller's request.
 *)
  DSERR_OUTOFMEMORY               = E_OUTOFMEMORY ;
(*
 * The specified WAVE format is not supported
 *)
  DSERR_BADFORMAT                 = $88780000 + 100 ;
(*
 * The function called is not supported at this time
 *)
  DSERR_UNSUPPORTED               = E_NOTIMPL ;
(*
 * No sound driver is available for use
 *)
  DSERR_NODRIVER                  = $88780000 + 120 ;
(*
 * This object is already initialized
 *)
  DSERR_ALREADYINITIALIZED        = $88780000 + 130 ;
(*
 * This object does not support aggregation
 *)
  DSERR_NOAGGREGATION             = CLASS_E_NOAGGREGATION ;
(*
 * The buffer memory has been lost, and must be Restored.
 *)
  DSERR_BUFFERLOST                = $88780000 + 150 ;
(*
 * Another app has a higher priority level, preventing this call from
 * succeeding.
 *)
  DSERR_OTHERAPPHASPRIO           = $88780000 + 160 ;
(*
 * The Initialize() member on the Direct Sound Object has not been
 * called or called successfully before calls to other members.
 *)
  DSERR_UNINITIALIZED             = $88780000 + 170 ;

//==========================================================================;
//
//                               Flags...
//
//==========================================================================;

  DSCAPS_PRIMARYMONO          = $00000001 ;
  DSCAPS_PRIMARYSTEREO        = $00000002 ;
  DSCAPS_PRIMARY8BIT          = $00000004 ;
  DSCAPS_PRIMARY16BIT         = $00000008 ;
  DSCAPS_CONTINUOUSRATE       = $00000010 ;
  DSCAPS_EMULDRIVER           = $00000020 ;
  DSCAPS_CERTIFIED            = $00000040 ;
  DSCAPS_SECONDARYMONO        = $00000100 ;
  DSCAPS_SECONDARYSTEREO      = $00000200 ;
  DSCAPS_SECONDARY8BIT        = $00000400 ;
  DSCAPS_SECONDARY16BIT       = $00000800 ;

  DSBPLAY_LOOPING             = $00000001 ;

  DSBSTATUS_PLAYING           = $00000001 ;
  DSBSTATUS_BUFFERLOST        = $00000002 ;
  DSBSTATUS_LOOPING           = $00000004 ;

  DSBLOCK_FROMWRITECURSOR     = $00000001 ;

  DSSCL_NORMAL                = 1 ;
  DSSCL_PRIORITY              = 2 ;
  DSSCL_EXCLUSIVE             = 3 ;
  DSSCL_WRITEPRIMARY          = 4 ;

// flags for IDirectSound3DBuffer::SetMode
  DS3DMODE_NORMAL             = 0 ;      // default must be 0
  DS3DMODE_HEADRELATIVE       = 1 ;
  DS3DMODE_DISABLE            = 2 ;

// flags for dwApply parameter of some 3D functions
  DS3D_IMMEDIATE              = 0 ;
  DS3D_DEFERRED               = 1 ;

// default values for 3d factors
  DS3D_DEFAULTDISTANCEFACTOR  = 1.0 ;
  DS3D_DEFAULTROLLOFFFACTOR   = 1.0 ;
  DS3D_DEFAULTDOPPLERFACTOR   = 1.0 ;

  DSBCAPS_PRIMARYBUFFER       = $00000001 ;
  DSBCAPS_STATIC              = $00000002 ;
  DSBCAPS_LOCHARDWARE         = $00000004 ;
  DSBCAPS_LOCSOFTWARE         = $00000008 ;
  DSBCAPS_CTRL3D              = $00000010 ;
  DSBCAPS_CTRLFREQUENCY       = $00000020 ;
  DSBCAPS_CTRLPAN             = $00000040 ;
  DSBCAPS_CTRLVOLUME          = $00000080 ;
  DSBCAPS_CTRLDEFAULT         = $000000E0 ;  // Pan + volume + frequency.
  DSBCAPS_CTRLALL             = $000000F0 ;  // All control capabilities
  DSBCAPS_STICKYFOCUS         = $00004000 ;
  DSBCAPS_GLOBALFOCUS         = $00008000 ;
  DSBCAPS_GETCURRENTPOSITION2 = $00010000 ;  // More accurate play cursor under emulation

  DSSPEAKER_HEADPHONE         = 1 ;
  DSSPEAKER_MONO              = 2 ;
  DSSPEAKER_QUAD              = 3 ;
  DSSPEAKER_STEREO            = 4 ;
  DSSPEAKER_SURROUND          = 5 ;

type

  LPDSENUMCALLBACK = function ( lpGuid: PGUID ; lpstrDescription: LPSTR ;
      lpstrModule: LPSTR ; lpContext: Pointer ): BOOL ; stdcall ;

function DirectSoundCreate ( lpGuid: PGUID ; var ppDS: IDirectSound ;
    pUnkOuter: IUnknown ): HRESULT ; stdcall ;
function DirectSoundEnumerate ( lpCallback: LPDSENUMCALLBACK ;
    lpContext: Pointer ): HRESULT ; stdcall ;


implementation

function DirectSoundEnumerate ; external 'DSOUND.DLL'
    name 'DirectSoundEnumerateA' ;
function DirectSoundCreate ; external 'DSOUND.DLL' ;



end.

